<?php

if (!defined('sugarEntry') || !sugarEntry) {
	die('Not A Valid Entry Point');
}
require_once 'modules/GCal/license/GCalLicense.php';
class GCalController extends SugarController {
	public function action_configureGCal() {
		$validate = GCalLicense::isValid();
		if ($validate !== true) {
			header('Location: index.php?module=GCal&action=license_gcal');
		}
		$this->view = 'configure_gcal';

		///////////////////////////////////////////////////////////////////////////////
		//// HANDLE CHANGES AFTER SUBMIT

		if (isset($_REQUEST['process']) && $_REQUEST['process'] == 'true') {
			require_once 'modules/Administration/Administration.php';

			$admin = new Administration();
			$admin->retrieveSettings();
			if (!array_key_exists('gcal_enable', $_REQUEST)) {
				$gcal_enable = 0;
			} else {
				$gcal_enable = 1;
			}

			if (!empty($gcal_enable)) {
				$admin->saveSetting("gcal", "enable", 1);
			} else {
				$admin->saveSetting("gcal", "enable", '');
			}

			$admin->saveSetting("gcal", "client_id", '');
			if (!empty($_REQUEST['gcal_client_id'])) {
				$admin->saveSetting("gcal", "client_id", $_REQUEST['gcal_client_id']);
			}

			$admin->saveSetting("gcal", "client_secret", '');
			if (!empty($_REQUEST['gcal_client_secret'])) {
				$admin->saveSetting("gcal", "client_secret", $_REQUEST['gcal_client_secret']);
			}

			$admin->saveSetting("gcal", "redirect_uri", '');
			if (!empty($_REQUEST['gcal_redirect_uri'])) {
				$admin->saveSetting("gcal", "redirect_uri", $_REQUEST['gcal_redirect_uri']);
			}

			$admin->saveSetting("gcal", "name", '');
			if (!empty($_REQUEST['gcal_name'])) {
				$admin->saveSetting("gcal", "name", $_REQUEST['gcal_name']);
			}

			$admin->saveSetting("gcal", "event_module", '');
			if (!empty($_REQUEST['gcal_event_module'])) {
				$admin->saveSetting("gcal", "event_module", $_REQUEST['gcal_event_module']);
			}

			$admin->saveSetting("gcal", "from_module", '');
			if (!empty($_REQUEST['gcal_from_module'])) {
				$fromModules = implode(",", $_REQUEST["gcal_from_module"]);
				$admin->saveSetting("gcal", "from_module", $fromModules);
			}

			if (!in_array('gcal', $admin->config_categories)) {
				$admin->config_categories[] = "gcal";
			}

			header('Location: index.php?module=Administration&action=index');
		}
	}
	public function action_license_gcal() {
		$this->view = 'license_gcal';
	}
	public function action_test() {
		$this->view = 'test';
	}
}
