<?php

if (empty($_REQUEST['method'])) {
	header('HTTP/1.1 400 Bad Request');
	$response = "method is required.";
	$json = getJSONobj();
	echo $json->encode($response);
}

//load license validation config
global $currentModule;
require_once 'modules/' . $currentModule . '/license/GCalLicense.php';

if ($_REQUEST['method'] == 'validate') {
	GCalLicense::validate();
} else if ($_REQUEST['method'] == 'change') {
	GCalLicense::change();
} else if ($_REQUEST['method'] == 'add') {
	GCalLicense::add();
} else if ($_REQUEST['method'] == 'test') {
	//optional param: user_id - test if a specific user has access to the add-on
	//Sugar 6: /index.php?module=SampleLicenseAddon&action=outfitterscontroller&method=test&to_pdf=1
	//Sugar 7: #bwc/index.php?module=SampleLicenseAddon&action=outfitterscontroller&method=test&to_pdf=1

	$user_id = null;
	if (!empty($_REQUEST['user_id'])) {
		$user_id = $_REQUEST['user_id'];
	}
	$validate_license = GCalLicense::isValid($currentModule, $user_id, true);

	if ($validate_license !== true) {
		echo "License did NOT validate.<br/><br/>Reason: " . $validate_license;
	} else {
		echo "License validated";
	}
}
