<?php
$dictionary['Contact']['fields']['product_type'] = array(
  'name' => 'product_type',
  'type' => 'enum',
  'options' => 'product_type_dom',
  'label' => 'LBL_PRODUCT_TYPE',
  'default' => '',
  'required' => false,
  'len' => 100,
  'audited' => true,
  'massupdate' => false,
  'duplicate_merge' => 'enabled',
  'reportable' => true,
  'importable' => 'true',
  'studio' => 'visible',
  'dependency' => false,
);

$dictionary['Contact']['fields']['product_provider'] = array(
  'name' => 'product_provider',
  'vname' => 'LBL_PRODUCT_PROVIDER',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'The provider of the product',
);

$dictionary['Contact']['fields']['product_name'] = array(
  'name' => 'product_name',
  'vname' => 'LBL_PRODUCT_NAME',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'The name of the product',
);

// Custom Fields
$dictionary['Contact']['fields']['product_provider'] = array(
  'name' => 'product_provider',
  'vname' => 'LBL_PRODUCT_PROVIDER',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'The provider of the product',
);

$dictionary['Contact']['fields']['product_name'] = array(
  'name' => 'product_name',
  'vname' => 'LBL_PRODUCT_NAME',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'The name of the product',
);

$dictionary['Contact']['fields']['coverage_amount'] = array(
  'name' => 'coverage_amount',
  'vname' => 'LBL_COVERAGE_AMOUNT',
  'type' => 'currency',
  'comment' => 'The coverage amount',
);

$dictionary['Contact']['fields']['coverage_duration'] = array(
  'name' => 'coverage_duration',
  'vname' => 'LBL_COVERAGE_DURATION',
  'type' => 'int',
  'comment' => 'The coverage duration in years',
);

$dictionary['Contact']['fields']['premium_amount'] = array(
  'name' => 'premium_amount',
  'vname' => 'LBL_PREMIUM_AMOUNT',
  'type' => 'currency',
  'comment' => 'The premium amount',
);

$dictionary['Contact']['fields']['premium_frequency'] = array(
  'name' => 'premium_frequency',
  'vname' => 'LBL_PREMIUM_FREQUENCY',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'The premium payment frequency',
);

$dictionary['Contact']['fields']['funding_amount_fia'] = array(
  'name' => 'funding_amount_fia',
  'vname' => 'LBL_FUNDING_AMOUNT_FIA',
  'type' => 'currency',
  'comment' => 'The funding amount for FIA',
);

$dictionary['Contact']['fields']['product_duration_fia'] = array(
  'name' => 'product_duration_fia',
  'vname' => 'LBL_PRODUCT_DURATION_FIA',
  'type' => 'int',
  'comment' => 'The product duration for FIA in years',
);

$dictionary['Contact']['fields']['submit_date'] = array(
  'name' => 'submit_date',
  'vname' => 'LBL_SUBMIT_DATE',
  'type' => 'date',
  'comment' => 'The date of submission',
);

$dictionary['Contact']['fields']['approval_date'] = array(
  'name' => 'approval_date',
  'vname' => 'LBL_APPROVAL_DATE',
  'type' => 'date',
  'comment' => 'The date of approval',
);


$dictionary['Contact']['fields']['funded'] = array(
  'name' => 'funded',
  'vname' => 'LBL_FUNDED',
  'type' => 'enum',
  'options' => 'checkbox_dom',
  'comment' => 'Funded',
);

$dictionary['Contact']['fields']['in_force'] = array(
  'name' => 'in_force',
  'vname' => 'LBL_IN_FORCE',
  'type' => 'enum',
  'options' => 'checkbox_dom',
  'comment' => 'In Force',
);

$dictionary['Contact']['fields']['split_agent'] = array(
  'name' => 'split_agent',
  'vname' => 'LBL_SPLIT_AGENT',
  'type' => 'enum',
  'options' => 'checkbox_dom',
  'comment' => 'The Split Agent',
);

$dictionary['Contact']['fields']['split_agent_name'] = array(
  'name' => 'split_agent_name',
  'vname' => 'LBL_SPLIT_AGENT_NAME',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'Split Agent Name',
);
$dictionary['Contact']['fields']['split_agent_social'] = array(
  'name' => 'split_agent_social',
  'vname' => 'LBL_SPLIT_AGENT_SOCIAL',
  'type' => 'varchar',
  'len' => '255',
  'comment' => 'Split Agent Social',
);


 ?>