<?php
class SendEmailCls{
    function sendUserRegEmail($user_id, $password){
        global $sugar_config, $app_list_strings, $log ,$current_user;
        
        $userBean = BeanFactory::getBean('Users', $user_id);
        $email = $userBean->email1;
        $loginUrl = $sugar_config['login_url'];
        $systemName = $sugar_config['systemName'];
        $login_anchor = "<a href='".$loginUrl."' target='_blank'>".$systemName."</a>";
        $template = new EmailTemplate();
        $template->retrieve($sugar_config['userRegEmailTemplate']);
        $template->subject = "User registered successfully";
        // $template->body_html = str_replace("\$email", $userBean->email1, $template->body_html);
        $template->body_html = str_replace("\$contact_user_user_name", $userBean->user_name, $template->body_html);
        $template->body_html = str_replace("\$config_site_url", $login_anchor, $template->body_html);
        $template->body_html = str_replace("\$contact_user_user_hash", $password, $template->body_html);
        
        //$generated_file = array();
        //$file_path = 'custom/include/stripe-php-master/Termify-Terms-and-Conditions.pdf';
        //$fileName = "Termify-Terms-and-Conditions.pdf";
        //$generated_file[$fileName] = $file_path;
        
        try{
            $this->sendCstmEmail($email, $template->subject, $template->body_html, 1, 1, $generated_file);
        }
        catch(Exception $e){
            $error_msg = $e->getMessage();
            $GLOBALS['log']->fatal(["Email send error", $error_msg]);
        }
    }
    protected function sendCstmEmail($emailTo, $emailSubject, $emailBody, $parent_id, $parent_type, $attachments = array()){	
        if(empty($emailSubject) || empty($emailBody) || empty($emailTo)){
            return false;
        };
        global $app_list_strings, $sugar_config;
        require_once('modules/Emails/Email.php');
        require_once('include/SugarPHPMailer.php');
        $emailObj = new Email();
        $defaults = $emailObj->getSystemDefaultEmail();
        $mail = new SugarPHPMailer();
        $mail->setMailerForSystem();
        $mail->From = $defaults['email'];
        $mail->FromName = $defaults['name'];
        $mail->ClearAllRecipients();
        $mail->ClearReplyTos();
        $mail->Subject = from_html($emailSubject);
        $mail->Body = html_entity_decode($emailBody);
        $mail->AltBody = html_entity_decode($emailBody);
        $mail->prepForOutbound();
        $mail->AddBcc("basit@helfertech.net");
        if(isset($attachments)){
            foreach($attachments AS $file_name => $file_address){
                $mail->AddAttachment($file_address, $file_name);	
            }
        }
        if(is_array($emailTo)){
            foreach($emailTo as $emails){
                $mail->AddAddress($emails);				
            }
        }else{
            $mail->AddAddress($emailTo);
        }
        if (@$mail->Send()){
            
           if(is_array($emailTo)){
                foreach($emailTo as $id => $email){
                    $emailObj = new Email();
                    $emailObj->to_addrs= $email;
                    $emailObj->type= 'out';
                    $emailObj->deleted = '0';
                    $emailObj->name = $mail->Subject;
                    $emailObj->status = 'sent';
                    $emailObj->description = $mail->Body;
                    $emailObj->description_html = $mail->Body;
                    $emailObj->from_addr = $mail->From;
                    $emailObj->parent_type = $parent_type;
                    $emailObj->parent_id = $id;
                    $emailObj->date_sent = TimeDate::getInstance()->nowDb();
                    $emailObj->modified_user_id = '1';
                    $emailObj->created_by = '1';
                    $emailObj->save();
                }
            }else{
                    $emailObj->to_addrs= $emailTo;
                    $emailObj->type= 'out';
                    $emailObj->deleted = '0';
                    $emailObj->name = $mail->Subject;
                    $emailObj->status = 'sent';
                    $emailObj->description = $mail->Body;
                    $emailObj->description_html = $mail->Body;
                    $emailObj->from_addr = $mail->From;
                    $emailObj->parent_type = $parent_type;
                    $emailObj->parent_id = $parent_id;
                    $emailObj->date_sent = TimeDate::getInstance()->nowDb();
                    $emailObj->modified_user_id = '1';
                    $emailObj->created_by = '1';
                    $emailObj->save();
            }
            return true;
        }
        return false;
    }

    function generateRandomPassword($length = 12) {
        // Define a pool of characters to choose from
        $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        // Get the total length of the character pool
        $charsLength = strlen($chars);
        // Initialize the password variable
        $password = '';
        // Generate a random password
        for ($i = 0; $i < $length; $i++) {
            // Use the random function to select a character from the pool
            $password .= $chars[mt_rand(0, $charsLength - 1)];
        }
        return $password;
    }
}