<?php

class viewstripe_config_view extends SugarView
{
    
    public function display()
    {
        global $db;
        $stripe_config_data = array();
        $configurator = new Configurator();
        $stripe_config_data['stripSecretKey']           = (isset($configurator->config['stripSecretKey']) && $configurator->config['stripSecretKey']) ? $configurator->config['stripSecretKey'] : "";
        $stripe_config_data['stripePublicKey']          = (isset($configurator->config['stripePublicKey']) && $configurator->config['stripePublicKey']) ? $configurator->config['stripePublicKey'] : "";
        $stripe_config_data['webhook_sec']              = (isset($configurator->config['webhook_sec']) && $configurator->config['webhook_sec']) ? $configurator->config['webhook_sec'] : "";
        $stripe_config_data['stripe_subscription_url']  = (isset($configurator->config['stripe_subscription_url']) && $configurator->config['stripe_subscription_url']) ? $configurator->config['stripe_subscription_url'] : "";
        $smarty = new Sugar_Smarty();
        $smarty->assign('stripe_config_data', $stripe_config_data);
        $smarty->display('custom/modules/Administration/tpls/stripe_config_view.tpl');
     
    }
}
