<?php

/**
 * @Author: khwaish_nagdev
 * @Date:   2021-03-25 15:24:44
 * @Last Modified by:   khwaish_nagdev
 * @Last Modified time: 2021-04-09 21:20:35
 */
if (!defined('sugarEntry') || !sugarEntry) {
	die('Not A Valid Entry Point');
}

//At bottom of post_install - redirect to license validation page - CHANGE NAME BELOW - To your module name

function post_install() {
	$job = BeanFactory::getBean('Schedulers');
	$job->name = 'Sync Google Calendar Events';
	$job->job = 'function::sync_gcal';
	$job->date_time_start = '2005-01-01 00:00:00';
	$job->job_interval = '*/2::*::*::*::*';
	$job->status = 'Active';
	$job->catch_up = '1';
	$job->save();

	$job = BeanFactory::getBean('Schedulers');
	$job->name = 'Sync Google Calendar Events Updates - Meetings';
	$job->job = 'function::updateGCalMeetingEvents';
	$job->date_time_start = '2005-01-01 00:00:00';
	$job->job_interval = '*/2::*::*::*::*';
	$job->status = 'Active';
	$job->catch_up = '1';
	$job->save();

	$job = BeanFactory::getBean('Schedulers');
	$job->name = 'Sync Google Calendar Events Updates - Calls';
	$job->job = 'function::updateGCalCallEvents';
	$job->date_time_start = '2005-01-01 00:00:00';
	$job->job_interval = '*/2::*::*::*::*';
	$job->status = 'Active';
	$job->catch_up = '1';
	$job->save();

	$autoexecute = false;
	$show_output = false;
	require_once "modules/Administration/QuickRepairAndRebuild.php";
	$randc = new RepairAndClear();
	$randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);
}