<?php

if (!defined('sugarEntry')) {
	define('sugarEntry', true);
}

global $db;
require_once 'modules/Configurator/Configurator.php';
require_once "modules/Administration/QuickRepairAndRebuild.php";
$db->query("DELETE FROM config WHERE category='gcal'");
$db->query("DELETE  FROM schedulers WHERE job = 'function::sync_gcal'");
$db->query("DELETE  FROM schedulers WHERE job = 'function::updateGCalMeetingEvents'");
$db->query("DELETE  FROM schedulers WHERE job = 'function::updateGCalCallEvents'");
$files = glob('GC'); // get all file names
foreach ($files as $file) {
	// iterate files
	if (is_file($file)) {
		unlink($file); // delete file
	}
}

$randc = new RepairAndClear();
$randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);

function recursiveRemove($dir) {
	$structure = glob(rtrim($dir, "/") . '/*');
	if (is_array($structure)) {
		foreach ($structure as $file) {
			if (is_dir($file)) {
				recursiveRemove($file);
			} elseif (is_file($file)) {
				unlink($file);
			}

		}
	}
	rmdir($dir);
}
