<?php

if (!defined('sugarEntry') || !sugarEntry) {
	die('Not A Valid Entry Point');
}

require_once 'modules/Users/views/view.edit.php';

class customUsersViewEdit extends UsersViewEdit {

	function __construct() {
		parent::__construct();
	}

	function display() {
		$user_id = $this->bean->id;
		require_once 'modules/Administration/Administration.php';
		$admin = new Administration();
		$admin->retrieveSettings();
		$CLIENT_ID = $admin->settings['gcal_client_id'];
		$CLIENT_SECRET = $admin->settings['gcal_client_secret'];
		$REDIRECT_URI = $admin->settings['gcal_redirect_uri'];
		//require_once 'GC/settings.php';
		require_once 'modules/GCal/license/GCalLicense.php';
		$validate = GCalLicense::isValid('GCal');

		if ($validate === true) {
			$auth_url = 'https://accounts.google.com/o/oauth2/auth?scope=' . urlencode('https://www.googleapis.com/auth/calendar https://www.googleapis.com/auth/userinfo.profile https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/plus.me') . '&redirect_uri=' . urlencode($REDIRECT_URI) . '&response_type=code&client_id=' . $CLIENT_ID . '&access_type=offline&prompt=consent';
			//$GLOBALS['log']->fatal($auth_url);
			$authorize_gcal = '<a class="button" id="gcal_auth" target="_blank" name="button" href="' . $auth_url . '" title="Reauthorize GCal" value="Reauthorize Google Calendar">Reauthorize Google Calendar</a>';
			if (empty($this->bean->gcal_auth)) {
				$authorize_gcal = '<a class="button" id="gcal_auth" target="_blank" name="button" href="' . $auth_url . '" title="Authorize GCal" value="Authorize Google Calendar">Authorize Google Calendar</a>';
			}
			$this->ss->assign("GoogleAuth", from_html($authorize_gcal));
		} else {
			$this->ss->assign("GoogleAuth", from_html($validate));
		}
		parent::display();
	}
}

?>
